Index: q931.c
===================================================================
RCS file: /usr/cvsroot/libpri/q931.c,v
retrieving revision 1.108
diff -u -r1.108 q931.c
--- q931.c	25 Jan 2005 00:36:34 -0000	1.108
+++ q931.c	27 Jan 2005 04:58:22 -0000
@@ -1595,11 +1595,11 @@
 		switch(encoding) {
 		case 0:		/* BCD even */
 		case 1:		/* BCD odd */
-			pri_message("%d", (ie->data[idx-2] >> 4) & 0x0f);
-			value = value * 10 + ((ie->data[idx-2] >> 4) & 0x0f);
+			pri_message("%d", ie->data[idx-2] & 0x0f);
+			value = value * 10 + (ie->data[idx-2] & 0x0f);
 			if(!encoding || (idx+1 < len)) {	/* Special handling for BCD odd */
-				pri_message("%d", ie->data[idx-2] & 0x0f);
-				value = value * 10 + (ie->data[idx-2] & 0x0f);
+				pri_message("%d", (ie->data[idx-2] >> 4) & 0x0f);
+				value = value * 10 + ((ie->data[idx-2] >> 4) & 0x0f);
 			}
 			break;
 		case 2:		/* IA5 */
@@ -1645,9 +1645,9 @@
 			switch(encoding) {
 			case 0:		/* BCD even */
 			case 1:		/* BCD odd */
-				value = value * 10 + ((ie->data[idx-2] >> 4) & 0x0f);
+				value = value * 10 + (ie->data[idx-2] & 0x0f);
 				if(!encoding || (idx+1 < len))	/* Special handling for BCD odd */
-					value = value * 10 + (ie->data[idx-2] & 0x0f);
+					value = value * 10 + ((ie->data[idx-2] >> 4) & 0x0f);
 				break;
 			case 2:		/* IA5 */
 				value = value * 10 + (ie->data[idx-2] - '0');
